package me.totalfreedom.totalfreedommod.rank;

import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import net.luckperms.api.model.group.Group;
import net.luckperms.api.node.types.InheritanceNode;
import org.bukkit.ChatColor;

import java.util.stream.Stream;

public class GroupProvider
{
    public static final Component OPEN = Component.text("[", NamedTextColor.DARK_GRAY);
    public static final Component CLOSE = Component.text("]", NamedTextColor.DARK_GRAY);

    private final DisplayableGroup nonOp;
    private final DisplayableGroup op;
    private final DisplayableGroup masterBuilder;
    private final DisplayableGroup admin;
    private final DisplayableGroup seniorAdmin;

    public GroupProvider()
    {
        this.nonOp = new DisplayableGroup(
                "default",
                Component.text("Non-Ops"),
                Component.empty(),
                0,
                NamedTextColor.WHITE,
                null,
                false,
                false);

        this.op = new DisplayableGroup(
                "op",
                Component.text("Operators"),
                Component.text("Op"),
                1,
                NamedTextColor.GREEN,
                null,
                false,
                false);

        this.masterBuilder = new DisplayableGroup(
                "builder",
                Component.text("Master Builders"),
                Component.text("MB"),
                2,
                NamedTextColor.DARK_AQUA,
                ChatColor.DARK_AQUA,
                true,
                true);

        this.admin = new DisplayableGroup(
                "admin",
                Component.text("Administrators"),
                Component.text("Admin"),
                3,
                NamedTextColor.DARK_GREEN,
                ChatColor.DARK_GREEN,
                true,
                true);

        this.seniorAdmin = new DisplayableGroup(
                "senior",
                Component.text("Senior Administrators"),
                Component.text("SrA"),
                4,
                NamedTextColor.GOLD,
                ChatColor.GOLD,
                true,
                true);

        nonOp.save();
        op.save();
        masterBuilder.save();
        admin.save();
        seniorAdmin.save();
    }

    public DisplayableGroup getNonOp()
    {
        return nonOp;
    }

    public DisplayableGroup getOp()
    {
        return op;
    }

    public DisplayableGroup getMasterBuilder()
    {
        return masterBuilder;
    }

    public DisplayableGroup getAdmin()
    {
        return admin;
    }

    public DisplayableGroup getSeniorAdmin()
    {
        return seniorAdmin;
    }

    public InheritanceNode inheritanceNode(DisplayableGroup group)
    {
        return InheritanceNode.builder(group.getLuckPermsGroup()).build();
    }

    public DisplayableGroup fromLuckPerms(Group group)
    {
        return Stream.of(nonOp, op, masterBuilder, admin, seniorAdmin)
                .filter(displayableGroup -> displayableGroup.getLuckPermsGroup().equals(group))
                .findFirst()
                .orElse(nonOp);
    }

    public DisplayableGroup fromString(String arg)
    {
        return switch (arg.toLowerCase())
        {
            case "op" -> op;
            case "builder" -> masterBuilder;
            case "admin" -> admin;
            case "senior" -> seniorAdmin;
            default -> nonOp;
        };
    }
}